/*		
 *	Exemple numero 2 de sous-classement
 *	
 *	Auteur	:	Alexandre Abreu, 
 *	Date	:	11/2001
 *	
 *	Le contenu de ce fichier est exempt de tout droit, vous pouvez le ripper,
 *	le modifier, l'utiliser a vos souhaits.	
 */



// pour accelerer le temps de compilation et pour eviter d'inclure des choses non necessaires
//  dans le source final

#define WIN32_LEAN_AND_MEAN

/////////////////////////////////////////////////////////////////
///		inclusion d'entetes

#include <windows.h>
#include "resource.h"



/////////////////////////////////////////////////////////////////
///		variables globales

WNDPROC g_oldWndProc;



/////////////////////////////////////////////////////////////////
///		fonctions


//	StaticWndProc
//	DlgProc du controle EDIT sous classe

LRESULT CALLBACK StaticWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static int i;
	
	switch( msg ){

	// WM_MOUSEMOVE va etre envoye au controle dans le cas ou 
	//		le curseur de la souris passe dessus.
	case WM_MOUSEMOVE:
		
		// on change le texte
		SetWindowText( hwnd, "Bonjour, merci de venir me voir");		
		return TRUE;
		break;
		
	default:
		break;
	}
	
	// on fait bien attention a appeler l'ancienne DlgProc pour concerver les autres
	//		comportements de l'edit box
	return CallWindowProc(g_oldWndProc, hwnd, msg, wParam, lParam);	
}



//	MainWndProc
//	DlgProc du gui principal

LRESULT CALLBACK MainWndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{	
	switch( msg ){
	
	// on profite du WM_INITDIALOG pour sous-classer tous les controles voulus
	case WM_INITDIALOG:
		
		g_oldWndProc = (WNDPROC) SetWindowLong( GetDlgItem( hwnd, IDC_EDIT1 ), GWL_WNDPROC, (long)StaticWndProc);
		return TRUE;
		break;
	
	// cf au dessus.
	case WM_MOUSEMOVE:
		
		SetDlgItemText( hwnd, IDC_EDIT1, "Bonjour, je suis un controle sous-classe" );
		return TRUE;
		break;

	case WM_CLOSE:
		
		EndDialog( hwnd, 0 );
		return TRUE;
		break;
	
	case WM_COMMAND:
		
		switch( LOWORD(wParam) ){
			
		case IDOK:
			EndDialog( hwnd, 0 );
			break;
		}
		
		return TRUE;
		break;
	}
	
	return FALSE;	
}




//	WinMain
//	Point d'entree de notre programme

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd )
{
	::DialogBox( hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL,  (DLGPROC) MainWndProc);
	
	return 0;
}

